<template>
  <div class="container">
    <div class="row">
      <div class="col text-center mb-5">
        <h1 class="stylized-title">Factories</h1>
        <button v-if="isAdmin" type="button" class="custom-btn btn-7" @click="goToAddFactoryView"><span>Add New Factory</span></button>
        <button v-if="!isAdmin && !isWorker && !isManager" type="button" class="custom-btn btn-7" @click="goToRegisterView"><span>Register</span></button>
        <button v-if="!isAdmin && !isWorker && !isManager && !isKupac" type="button" class="custom-btn btn-7" @click="goToLoginView"><span>Login</span></button>
        <button type="button" class="custom-btn btn-7" @click="goToPurchasesView"><span>See Purchases</span></button>
        <button v-if="!(!isAdmin && !isWorker && !isManager && !isKupac)" type="button" class="custom-btn btn-7" @click="openEditUserModal"><span>See User Info</span></button>
        <button v-if="!(!isAdmin && !isWorker && !isManager && !isKupac)" type="button" class="custom-btn btn-7" @click="Logout"><span>Log out</span></button>
        <button v-if="isAdmin" class="custom-btn btn-7" @click="goToUserView"><span>View Users</span></button>
        <button v-if="isManager" class="custom-btn btn-7" @click="viewFactoryReport"><span>View Factory Report</span></button>
      </div>
    </div>

    <!-- Search and Filter Controls -->
    <div class="search-filters">
      <input v-model="search.name" placeholder="Search by Factory Name" @input="filterFactories">
      <input v-model="search.chocolateName" placeholder="Search by Chocolate Name" @input="filterFactories">
      <input v-model="search.location" placeholder="Search by Location" @input="filterFactories">
      <input v-model="search.averageRating" type="number" min="0" max="5" step="0.1" placeholder="Rating" @input="filterFactories">
      
      <select v-model="sortCriteria" @change="filterFactories">
        <option value="name">Name</option>
        <option value="location">Location</option>
        <option value="averageRating">Average Rating</option>
      </select>
      <select v-model="sortOrder" @change="filterFactories">
        <option value="asc">Ascending</option>
        <option value="desc">Descending</option>
      </select>
      
      <div class="checkbox-container">
        <input type="checkbox" v-model="filters.onlyOpenFactories" @change="filterFactories">
        <label>Show only open factories</label>
      </div>      

      <select v-model="filters.chocolateKind" @change="filterFactories">
        <option value="">All Kinds</option>
        <option value="Dark">Dark</option>
        <option value="Milk">Milk</option>
        <option value="White">White</option>
      </select>
      
      <select v-model="filters.chocolateType" @change="filterFactories">
        <option value="">All Types</option>
        <option value="Bar">Bar</option>
        <option value="Box">Box</option>
        <option value="Truffle">Truffle</option>
      </select>
    </div>

    <div class="row">
      <div v-for="factory in factories" :key="factory.id" class="col-sm-12 col-md-6 col-lg-4 mb-4" @click="goToFactoryDetail(factory.id)">
        <div class="card text-dark card-has-bg click-col" :style="{ backgroundImage: 'url(' + getLogoPath(factory.name.logo) + ')' }">
          <img class="card-img d-none" id="logo" :src="getLogoPath(factory.name.logo)" :alt="factory.name.name">
          <div class="card-img-overlay d-flex flex-column">
            <div class="card-body">
              <small class="card-meta mb-2">Chocolate Factory</small>
              <h4 class="card-title mt-0">
                <a class="text-dark">{{ factory.name.name }}</a>
              </h4>
              <small><i class="far fa-clock"></i> {{ factory.openingHours }}</small>
            </div>
            <div class="card-footer">
              <div class="media">
                <img class="mr-3 rounded-circle logo" src="https://assets.codepen.io/460692/internal/avatars/users/default.png?format=auto&version=1688931977&width=80&height=80" alt="Generic placeholder image">
                <div class="media-body">
                  <h6 class="my-0 text-dark d-block">{{ factory.name.name }}</h6>
                  <small>Average Rating: {{ factory.name.rating }}</small>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Modal for editing user information -->
    <div v-if="showEditUserModal" class="modal" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content glowing-box">
          <div class="modal-header">
            <!-- Title in orange -->
            <h5 class="modal-title" style="color: orange;">Edit User Information</h5>
            <button type="button" class="btn-close" @click="closeEditUserModal">&times;</button>
          </div>
          <div class="modal-body">
            <form @submit.prevent="updateUserInfo">
              <!-- Added spacing between fields -->
              <div style="margin-bottom: 15px;">
                <label for="firstName">First Name:</label>
                <input type="text" v-model="editUser.firstName" required style="width: 100%;">
              </div>
              <div style="margin-bottom: 15px;">
                <label for="lastName">Last Name:</label>
                <input type="text" v-model="editUser.lastName" required style="width: 100%;">
              </div>
              <div style="margin-bottom: 15px;">
                <label for="gender">Gender:</label>
                <input type="text" v-model="editUser.gender" required style="width: 100%;">
              </div>
              <div style="margin-bottom: 15px;">
                <label for="dateOfBirth">Date of Birth:</label>
                <input type="date" v-model="editUser.dateOfBirth" required style="width: 100%;">
              </div>
              <!-- Buttons aligned and spaced -->
              <div style="display: flex; justify-content: space-between;">
                <button type="submit" class="custom-btn btn-6"><span>Save changes</span></button>
                <button type="button" class="custom-btn btn-6-red" @click="closeEditUserModal"><span>Cancel</span></button>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>


<script>
import axios from 'axios';

export default {
  name: 'FactoryView',
  data() {
    return {
      factories: [],
      search: {
        name: '',
        chocolateName: '',
        location: '',
        averageRating: ''
      },
      sortCriteria: 'name',
      sortOrder: 'asc',
      filters: {
        onlyOpenFactories: false,
        chocolateKind: '',
        chocolateType: ''
      },
      isAdmin: false, // Dodato za proveru administratorske uloge
      isManager: false,
      isWorker: false,
      isKupac: false,
      showEditUserModal: false,
      editUser: {
        firstName: '',
        lastName: '',
        gender: '',
        dateOfBirth: ''
      }
    }
  },
  mounted() {
    this.fetchFactories();
    this.checkAdminRole();
    this.loadUserInfo();
  },
  methods: {
    fetchFactories() {
      // Kreiramo parametre za filtriranje i sortiranje koje šaljemo backendu
      const params = {
        name: this.search.name || undefined,
        chocolateName: this.search.chocolateName || undefined,
        location: this.search.location || undefined,
        averageRating: this.search.averageRating || undefined,
        sortBy: this.sortCriteria,
        sortOrder: this.sortOrder,
        onlyOpenFactories: this.filters.onlyOpenFactories ? 'true' : undefined,
        chocolateKind: this.filters.chocolateKind || undefined,
        chocolateType: this.filters.chocolateType || undefined
      };

      axios
        .get('http://localhost:3000/factories', { params })
        .then(response => {
          this.factories = response.data; // Dobijamo fabrike filtrirane i sortirane sa backend strane
        })
        .catch(error => {
          console.error("Error fetching factories", error);
        });
    },
    filterFactories() {
      // Ponovo pozivamo fetchFactories da bi se primenili filteri i sortiranje
      this.fetchFactories();
    },
    goToFactoryDetail(factoryId) {
    // Navigacija na stranicu sa detaljima o fabrici
    this.$router.push({ name: 'FactoryDetail', params: { id: factoryId } });
  },
    goToRegisterView() {
    // Navigacija ka stranici registracije
    this.$router.push({ name: 'Register' });
  },
  goToLoginView() {
    // Navigacija ka stranici prijave
    this.$router.push({ name: 'Login' });
  },
  goToPurchasesView() {
    // Navigacija ka stranici pregleda kupovina
    this.$router.push({ name: 'Purchases' });
  },
  Logout() {
    // Brisanje korisničkih podataka iz lokalnog skladišta i preusmeravanje
    localStorage.clear();  // Brisanje podataka iz localStorage
    this.isAdmin = false;
    this.isManager = false;
    this.isWorker = false;
    this.isKupac = false;
    this.$router.push({ name: 'Home' });  // Preusmeravanje na početnu stranicu
  },
    goToAddFactoryView() {
    this.$router.push({ name: 'AddFactory' }); // Ova ruta treba da postoji u vašem Vue Routeru
  },
  goToUserView() {
    this.$router.push({ name: 'UserView' }); // Ova ruta takođe treba da bude definisana u Vue Routeru
  },
  viewFactoryReport() {
    this.$router.push({ name: 'FactoryReport' }); // Koristi odgovarajuće ime rute
  },
    checkAdminRole() {
      const user = JSON.parse(localStorage.getItem('user'));
      if (user && user === 'Administrator') {
        this.isAdmin = true;
      } else if (user && user === 'Menadzer') {
        this.isManager = true;
      } else if (user && user === 'Radnik') {
        this.isWorker = true;
      } else if (user && user === 'Kupac') {
        this.isKupac = true;
      }
    },
    loadUserInfo() {
      const user = JSON.parse(localStorage.getItem('fulluser'));
      if (user) {
        this.editUser = { ...user };
      }
    },
    getLogoPath(logo) {
      // Implementacija za dobavljanje putanje do logotipa
      if (!logo) {
        console.error("Logo is undefined");
        return '/src/assets/default-logo.png'; // Putanja do podrazumevanog logotipa
      }
      return `/src/assets/${logo}`; // Pretpostavka da se logo nalazi u assets folderu
    },
    openEditUserModal() {
      this.showEditUserModal = true;
    },
    closeEditUserModal() {
      this.showEditUserModal = false;
    },
    updateUserInfo() {
      const user = JSON.parse(localStorage.getItem('fulluser'));
      if (user) {
        axios.put(`http://localhost:3000/users/${user.username}`, this.editUser)
          .then(response => {
            console.log("User info updated", response);
            localStorage.setItem('fulluser', JSON.stringify(this.editUser));
            this.closeEditUserModal();
          })
          .catch(error => {
            console.error("Error updating user info", error);
          });
      }
    }
  }
}
</script>


<style scoped>
@import url('https://fonts.googleapis.com/css2?family=Open+Sans:wght@400;600&display=swap');

body {
  background: linear-gradient(to right, #f12711, #f5af19); /* Crveno-narandžasti gradijent */
  height: 100vh;
  display: flex;
  justify-content: center;
  align-items: center;
  margin: 0;
}
h1 {
  color: #060606;
}

.lead {
  color: #aaa;
}

.wrapper {
  display: flex;
  justify-content: center;
  align-items: center;
  min-height: 100vh;
}

.container {
  background: #fff;
  padding: 20px;
  border-radius: 8px;
  box-shadow: 0 0 20px rgba(0,0,0,0.1);
}

button {
  margin: 10px;
}
.custom-btn {
  width: 180px;
  height: 40px;
  color: #fff;
  border-radius: 5px;
  padding: 10px 25px;
  font-family: 'Lato', sans-serif;
  font-weight: 500;
  background: transparent;
  cursor: pointer;
  transition: all 0.3s ease;
  position: relative;
  display: inline-block;
  box-shadow: inset 2px 2px 2px 0px rgba(255,255,255,.5),
              7px 7px 20px 0px rgba(0,0,0,.1),
              4px 4px 5px 0px rgba(0,0,0,.1);
  outline: none;
}

/* 7 */
.btn-7 {
  background: linear-gradient(0deg, rgba(255,151,0,1) 0%, rgba(251,75,2,1) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
}
.btn-7 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-7:before,
.btn-7:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7:before {
  height: 0%;
  width: 2px;
}
.btn-7:after {
  width: 0%;
  height: 2px;
}
.btn-7:hover {
  color: rgba(251,75,2,1);
  background: transparent;
}
.btn-7:hover:before {
  height: 100%;
}
.btn-7:hover:after {
  width: 100%;
}
.btn-7 span:before,
.btn-7 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgba(251,75,2,1);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-7 span:before {
  width: 2px;
  height: 0%;
}
.btn-7 span:after {
  height: 2px;
  width: 0%;
}
.btn-7 span:hover:before {
  height: 100%;
}
.btn-7 span:hover:after {
  width: 100%;
}

.card {
  border: none;
  transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);
  overflow: hidden;
  border-radius: 20px;
  min-height: 500px;
  box-shadow: 0 0 12px 0 rgba(0, 0, 0, 0.2);

  @media (max-width: 768px) {
    min-height: 400px;
  }

  @media (max-width: 420px) {
    min-height: 350px;
  }

  &.card-has-bg {
    transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center center;
    &:before {
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      background: inherit;
      -webkit-filter: grayscale(1);
      -moz-filter: grayscale(100%);
      -ms-filter: grayscale(100%);
      -o-filter: grayscale(100%);
      filter: grayscale(100%);
    }

    &:hover {
      transform: scale(0.98);
      box-shadow: 0 0 5px -2px rgba(0, 0, 0, 0.3);
      background-size: 80%;
      transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);

      .card-img-overlay {
        transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);
        background: rgb(255,186,33);
        background: linear-gradient(0deg, rgba(255,186,33,0.5) 0%, rgba(255,186,33,1) 100%);
      }
    }
  }
  
  .card-footer {
    background: none;
    border-top: none;

    .media img {
      border: solid 3px rgba(255, 255, 255, 0.3);
    }
  }

  .card-title {
    font-weight: 800;
  }

  .card-meta {
    color: rgba(0, 0, 0, 0.3);
    text-transform: uppercase;
    font-weight: 500;
    letter-spacing: 2px;
  }

  .card-body {
    transition: all 500ms cubic-bezier(0.19, 1, 0.22, 1);
  }

  &:hover .card-body {
    margin-top: 30px;
    transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);
  }

  cursor: pointer;
  transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);

  .card-img-overlay {
    transition: all 800ms cubic-bezier(0.19, 1, 0.22, 1);
    background: rgb(255,186,33);
    background: linear-gradient(0deg, rgba(255,186,33,0.3785889355742297) 0%, rgba(255,186,33,1) 100%);
  }
}

.logo {
  width: 30px;
  height: 30px;
}

.search-filters {
  margin-bottom: 20px;
}

.search-filters input,
.search-filters select {
  margin-right: 10px;
  margin-bottom: 10px;
}

.btn-rounded {
  border-radius: 50px;
}
.modal {
  display: flex; 
  justify-content: center; 
  align-items: center; 
  position: fixed; 
  z-index: 1050; 
  left: 0; 
  top: 0; 
  width: 100%; 
  height: 100%; 
  background-color: rgba(0, 0, 0, 0.5);
}

.modal-dialog {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh; /* Full height */
}

.glowing-box {
  background-color: #fff;
  position: relative;
  border-radius: 20px;
  padding: 20px;
  box-shadow: 0 0 60px rgba(251, 255, 12, 0.5); /* Blagi sjaj */
  animation: glow-animation 3s infinite alternate;
}

@keyframes glow-animation {
  from {
    box-shadow: 0 0 20px rgba(142, 61, 2, 0.5), 0 0 30px rgba(255, 186, 33, 0.5);
  }
  to {
    box-shadow: 0 0 40px rgba(255, 186, 33, 1), 0 0 60px rgba(255, 186, 33, 1);
  }
}

/* Dugme za zatvaranje */
.btn-close {
  background: none;
  border: none;
  color: #333;
  font-size: 1.5rem;
  cursor: pointer;
}

.btn-close:hover {
  color: rgba(255,151,0,1);
}

.modal-content {
  position: relative;
  background-color: #fff;
  background-clip: padding-box;
  border-radius: 8px;
  padding: 20px;
  animation: modal-appear 0.5s ease-out;
}


.modal-header {
  display: flex;
  align-items: flex-start;
  justify-content: space-between;
  padding: 1rem;
  border-bottom: 1px solid #dee2e6;
  border-top-left-radius: 0.3rem;
  border-top-right-radius: 0.3rem;
}

.modal-body {
  position: relative;
  flex: 1 1 auto;
  padding: 1rem;
}

.modal-footer {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  padding: 1rem;
  border-top: 1px solid #dee2e6;
  border-bottom-right-radius: 0.3rem;
  border-bottom-left-radius: 0.3rem;
}

.btn-close {
  padding: 0.25rem 0.5rem;
  margin: -0.25rem -0.5rem -0.25rem auto;
  cursor: pointer;
}

/* Stilizacija kontejnera za filtere */
.search-filters {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
  padding: 10px 20px;
  background-color: #f8f9fa;
  border-radius: 8px;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  margin-bottom: 20px;
  align-items: center;
}

.search-filters input,
.search-filters select {
  margin: 5px;
  padding: 8px 12px;
  border: 1px solid #ced4da;
  border-radius: 5px;
  box-shadow: 0 1px 3px rgba(0, 0, 0, 0.1);
  width: 220px;
}

/* Stilizacija checkbox-a i label-a */
.search-filters input[type="checkbox"] {
  width: auto;
  margin-right: 5px; /* Smanjen razmak desno od checkbox-a */
}

.checkbox-container {
  display: flex;
  align-items: center; /* Poravnava checkbox i label po sredini */
  margin-top: 5px;
}

.checkbox-container label {
  margin: 0;
  font-weight: bold; /* Možeš ukloniti ako ne želiš podebljani tekst */
}

.search-filters input::placeholder {
  color: #6c757d;
}

@media (max-width: 768px) {
  .search-filters {
    flex-direction: column;
  }

  .search-filters input,
  .search-filters select {
    width: 100%;
  }
}

/* Stil za naslov */
.stylized-title {
  font-size: 4rem;
  font-family: 'Trebuchet MS', sans-serif;
  font-weight: bold;
  color: #fff;
  text-transform: uppercase; /* Velika slova */
  letter-spacing: 5px; /* Razmak između slova */
  position: relative;
  animation: fadeIn 2s ease-in-out, textGlow 4s ease-in-out infinite alternate;
  text-shadow: 2px 2px 5px rgba(0, 0, 0, 0.5);
}

/* Efekat unutrašnje svetlosti */
.stylized-title::before {
  content: '';
  position: absolute;
  top: 0;
  left: 50%;
  width: 100%;
  height: 100%;
  background: rgba(255, 255, 255, 0.2);
  z-index: -1;
  filter: blur(20px);
  transform: translateX(-50%);
}

/* Animacija ulaska */
@keyframes fadeIn {
  0% {
    opacity: 0;
    transform: translateY(-20px);
  }
  100% {
    opacity: 1;
    transform: translateY(0);
  }
}

/* Efekat pulsirajuće svetlosti */
@keyframes textGlow {
  from {
    text-shadow: 0 0 10px #fff, 0 0 20px #f39c12, 0 0 30px #f39c12, 0 0 40px #e74c3c, 0 0 50px #e74c3c, 0 0 60px #e74c3c;
  }
  to {
    text-shadow: 0 0 20px #fff, 0 0 30px #f39c12, 0 0 40px #f39c12, 0 0 50px #e74c3c, 0 0 60px #e74c3c, 0 0 70px #e74c3c;
  }
}

/* 6 - Zeleno dugme */
.btn-6 {
  background: linear-gradient(0deg, rgb(42, 156, 43) 0%, rgb(81, 246, 4) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6 span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6:before,
.btn-6:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(35, 251, 2);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6:before {
  height: 0%;
  width: 2px;
}
.btn-6:after {
  width: 0%;
  height: 2px;
}
.btn-6:hover {
  color: rgb(87, 198, 109);
  background: transparent;
}
.btn-6:hover:before {
  height: 100%;
}
.btn-6:hover:after {
  width: 100%;
}
.btn-6 span:before,
.btn-6 span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(2, 251, 139);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6 span:before {
  width: 2px;
  height: 0%;
}
.btn-6 span:after {
  height: 2px;
  width: 0%;
}
.btn-6 span:hover:before {
  height: 100%;
}
.btn-6 span:hover:after {
  width: 100%;
}

/* 6 - Crveno dugme */
.btn-6-red {
  background: linear-gradient(0deg, rgb(220, 53, 69) 0%, rgb(255, 107, 114) 100%);
  line-height: 42px;
  padding: 0;
  border: none;
  color: white;
  border-radius: 5px;
  cursor: pointer;
  position: relative;
  display: inline-block;
  transition: all 0.3s ease;
}
.btn-6-red span {
  position: relative;
  display: block;
  width: 100%;
  height: 100%;
}
.btn-6-red:before,
.btn-6-red:after {
  position: absolute;
  content: "";
  right: 0;
  bottom: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red:before {
  height: 0%;
  width: 2px;
}
.btn-6-red:after {
  width: 0%;
  height: 2px;
}
.btn-6-red:hover {
  color: rgb(255, 150, 150);
  background: transparent;
}
.btn-6-red:hover:before {
  height: 100%;
}
.btn-6-red:hover:after {
  width: 100%;
}
.btn-6-red span:before,
.btn-6-red span:after {
  position: absolute;
  content: "";
  left: 0;
  top: 0;
  background: rgb(255, 80, 80);
  box-shadow: -7px -7px 20px 0px rgba(255,255,255,.9),
              -4px -4px 5px 0px rgba(255,255,255,.9),
              7px 7px 20px 0px rgba(0,0,0,.2),
              4px 4px 5px 0px rgba(0,0,0,.3);
  transition: all 0.3s ease;
}
.btn-6-red span:before {
  width: 2px;
  height: 0%;
}
.btn-6-red span:after {
  height: 2px;
  width: 0%;
}
.btn-6-red span:hover:before {
  height: 100%;
}
.btn-6-red span:hover:after {
  width: 100%;
}

</style>
